#================================================================================================================================
# MIT LICENCE
# Copyright (c) 2019, Aziza Merzouki
#  
#  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction, including without limitation 
#  the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, 
#  and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#  
#  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
#   INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
#   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
#   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
#   OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
#================================================================================================================================

library(rworldmap)
library(rworldxtra)
library(manipulate)

#####################################################

# Plot Variables Map, Given a Matrix M where Columns = Variables and Rows = Countries. 
plotFeatureMaps <- function(M,mainDir,fileName_spec=NULL){
  
  # M = t(M)
  print("plotFeaturesMap(...)")
  print(M)
  
  Variable = colnames(M)
  n = length(Variable)
  print(paste("n = ", n))
  Country = rownames(M)
  # Add the Country Names to the Dataframe of Feature Associations
  M=data.frame(M,Country)
  
  # print("M with Country Column = ")
  # print(M)
  
  # Plot Map of Features
  # # Interactive Map
  # sPDF <- getMap(resolution="high")
  # spdf <- joinCountryData2Map(M,joinCode='NAME',nameJoinColumn="Country")
  # print(Variable[1])
  # # manipulate(mapCountryData(spdf,nameColumnToPlot= Variable[i], mapRegion="africa",mapTitle= paste("Feature Map ",Variable[i]),catMethod=seq(floor(min(M[,Variable[i]])),ceiling(max(M[,Variable[i]])),by=(ceiling(max(M[,Variable[i]]))-floor(min(M[,Variable[i]])))/10)), i=slider(1,n))
  # manipulate(mapCountryData(spdf,nameColumnToPlot= Variable[i], mapRegion="africa",mapTitle= Variable[i],catMethod=seq(floor(min(M[,Variable[i]])),ceiling(max(M[,Variable[i]])),by=(ceiling(max(M[,Variable[i]]))-floor(min(M[,Variable[i]])))/10)), i=slider(1,n))
  # # Add Country Labels on the Map
  # labelCountries(spdf,nameCountryColum="Country",cex=0.5,col="black")

  # Save Separate Maps
  extension = '.pdf'
  # extension = '.png'
  for (i in c(1:n)){
    if (is.null(fileName_spec)){
      fileName = paste(mainDir,'/map_var_',i,extension,sep='')
    } else{
      fileName = paste(mainDir,'/map_var_',i,'_',fileName_spec,extension,sep='')
    }
    pdf(fileName)
    # png(fileName)

    # Plot Map of Features
    sPDF <- getMap(resolution="high")
    spdf <- joinCountryData2Map(M,joinCode='NAME',nameJoinColumn="Country")
    print(Variable[1])
    # mapCountryData(spdf,nameColumnToPlot= Variable[i], mapRegion="africa",mapTitle= paste("Feature Map ",Variable[i]),catMethod=seq(floor(min(M[,Variable[i]])),ceiling(max(M[,Variable[i]])),by=(ceiling(max(M[,Variable[i]]))-floor(min(M[,Variable[i]])))/10))
    mapCountryData(spdf,nameColumnToPlot= Variable[i], mapRegion="africa",mapTitle= Variable[i],catMethod=seq(floor(min(M[,Variable[i]])),ceiling(max(M[,Variable[i]])),by=(ceiling(max(M[,Variable[i]]))-floor(min(M[,Variable[i]])))/10))
    # Add Country Labels on the Map
    # labelCountries(spdf,nameCountryColum="Country",cex=0.5,col="black")
    dev.off()
  }
}
